# Created : 06/12/2021
# POLYNOM CLASS

import math

class polynome():
    def __init__(self, coefs : list):
        self.coefs = coefs
        self.prime_mod = 229

    def show(self):
        for i in range(len(self.coefs) - 1, -1, -1):
            power = ""
            if self.coefs[i] != 0:
                coef = str(self.coefs[i])
                if i != 0: # its not 0's degree
                    power = f"x^{i} + "
            else:
                coef = ""
            print(f"{coef}{power}", end="")
        print() # new line
    
    def add(self, poly_2):
        coeff_poly_1 = self.coefs
        if len(coeff_poly_1) > len(poly_2.coefs):
            while len(coeff_poly_1) > len(poly_2.coefs):
                poly_2.coefs.append(0)
        else:
            while len(coeff_poly_1) < len(poly_2.coefs):
                coeff_poly_1.append(0)
        
        for i in range(0, len(coeff_poly_1)):
            coeff_poly_1[i] = (coeff_poly_1[i] + poly_2.coefs[i]) % self.prime_mod
        
        return polynome(coeff_poly_1)

    def mul(self, poly_2):
        coeff_poly_res = [0] * (len(self.coefs) + len(poly_2.coefs) - 1)
        for index_1, value_1 in enumerate(self.coefs):
            for index_2, value_2 in enumerate(poly_2.coefs):
                coeff_poly_res[index_1 + index_2] += value_1 * value_2
        return polynome(coeff_poly_res)
    
    def evaluate(self, x):
        # Using horner method
        res = 0
        for i in range(len(self.coefs) - 1, -1, -1):
            res = (res * x + self.coefs[i])
        return res
